import random
random.seed("basic03")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test([2, 3, 4, 5, 6], [(1, 2, 4), (1, 2, 3), (0, 1, 1), (0, 4, 7), (1, 1, 3), (1, 1, 4)])
        
    def generate_min_tests(self):
        self.print_test([1], [(1, 1, 1)])
        self.print_test([1], [(1, 1, 1), (0, 1, 2), (1, 1, 1)])
        self.print_test([2], [(1, 1, 1), (0, 1, 1), (1, 1, 1)])
        self.print_test([2], [(0, 1, 1), (1, 1, 1)])
                                                                    
    def generate_hand_tests(self):
        for i in range(10):
            self.generate_random_test(10, 30, 20)

    def generate_random_test(self, maxn, maxx, maxq):
        n = maxn
        arr = []
        for i in range(n):
            arr.append(random.randint(1, maxx))
        q = maxq
        qs = []
        for i in range(q):
            typeq = random.randint(0, 1)
            if typeq == 0:
                idx = random.randint(1, n)
                x = random.randint(1, maxx)
                qs.append((typeq, idx, x))
            else:
                l = random.randint(1, n)
                r = random.randint(l, n)
                qs.append((typeq, l, r))
        self.print_test(arr, qs)

    def generate_primes(self, maxx):
        primes = []
        for i in range(2, maxx + 1):
            ok = False
            j = 2
            while j * j <= i:
                if i % j == 0:
                    ok = True
                    break
                j += 1
            if not ok:
                primes.append(i)
        return primes

    def generate_max_tests(self, maxn, maxx, maxq):
        primes = self.generate_primes(maxx)
        numbers = [6006, 9282]

        n = maxn
        arr = []
        for i in range(n):
            idx = random.randint(7, len(primes) - 1)
            typeq = random.randint(0, 2)
            if typeq <= 1:
                arr.append(numbers[typeq])
            else:
                arr.append(random.randint(1, maxx))
        qs = []
        q = maxq
        for i in range(q):
            l = random.randint(1, 2)
            r = n - random.randint(0, 1)
            qs.append((1, l, r))
        self.print_test(arr, qs)

        n = maxn
        arr = []
        for i in range(n):
            idx = random.randint(7, len(primes) - 1)
            typeq = random.randint(0, 2)
            if typeq <= 1:
                arr.append(numbers[typeq])
            else:
                arr.append(primes[idx])
        qs = []
        q = maxq
        for i in range(q):
            typeq = random.randint(0, 1)
            if typeq == 0:
                idx = random.randint(1, n)
                x = primes[random.randint(0, len(primes) - 1)]
                cnt = min(5, maxx // x)
                qs.append((typeq, idx, x * random.randint(1, cnt)))
            else: 
                l = random.randint(1, 2)
                r = n - random.randint(0, 1)
                qs.append((typeq, l, r))
        self.print_test(arr, qs)

        n = maxn
        arr = []
        for i in range(n):
            arr.append(primes[i % len(primes)])
        for i in range(n):
            maxd = maxx // arr[i]
            arr[i] *= random.randint(max(1, maxd // 2), maxd)
        qs = []
        q = maxq
        for i in range(q):
            l = random.randint(1, 2)
            r = n - random.randint(0, 1)
            qs.append((1, l, r))
        self.print_test(arr, qs)

    def print_test(self, arr, qs):
        self.test_number += 1
        test_name = "../tests/" + "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        n = len(arr)
        q = len(qs)
        print(n, file=test_file)
        print(' '.join(str(element) for element in arr), file=test_file)
        print(q, file=test_file)
        print('\n'.join(' '.join(str(element) for element in query) for query in qs), file=test_file)
        test_file.close()

    def generate_all_tests(self):
        maxn = 5 * 10**4
        maxx = 10**4
        maxq = 10**4

        self.generate_samples()
        self.generate_min_tests()
        self.generate_hand_tests()
        
        for i in range(20):
            self.generate_random_test(maxn, maxx, maxq)
        self.generate_max_tests(maxn, maxx, maxq)        

import os, shutil
if os.path.exists('../tests'):
    print('Directory tests is already exists')
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
try:
    os.makedirs('../tests')
except OSError:
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)