#include <bits/stdc++.h>

long long gcd(long long a, long long b) {
    while (b > 0) {
        a %= b;
        std::swap(a, b);
    }
    return a;
}

int factorize(long long x) {
    int ans = 0;
    for (long long i = 2; i * i <= x; i++) {
        while (x % i == 0)
            x /= i, ++ans;
    }
    if (x > 1)
        ++ans;
    return ans;
}

const int maxp = 100;

bool was[maxp][maxp][maxp];
bool dp[maxp][maxp][maxp];

bool calc_dp(int pa, int pd, int pb) {
    if (pa + pd + pb == 0)
        return false;
    if (was[pa][pd][pb])
        return dp[pa][pd][pb];

    was[pa][pd][pb] = true;
    bool ans = false;
    for (int i = 0; i <= pa; i++)
    for (int j = 0; j <= pd; j++) {
        if (i == 0 && j == 0)
            continue;
        if (i == 0)
            ans |= !calc_dp(pa, pd - j, pb);
        ans |= !calc_dp(pa - i, pd - j, pb + j);
    }
    for (int i = 0; i <= pb; i++)
    for (int j = 0; j <= pd; j++) {
        if (i == 0 && j == 0)
            continue;
        ans |= !calc_dp(pa + j, pd - j, pb - i);
    }
    return dp[pa][pd][pb] = ans;
}

int main() {
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);
    long long a, b;
    std::cin >> a >> b;
    long long d = gcd(a, b);
    int pa = factorize(a / d);
    int pb = factorize(b / d);
    int pd = factorize(d);
    std::cout << (calc_dp(pa, pd, pb) ? "Lucky wins\n" : "Alf wins\n");
    return 0;
}
                   