#include <iostream>
#include <cstdio>
#include <memory.h>
#include <map>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

const int maxn = 5000;

int n;
vector<int> v;
int dp[maxn][maxn];
int nxt[maxn][maxn];
vector<int> divisors[maxn];

void fact(int x) {
    for (int i = 1; i * i <= x; i++) {
        if (x % i == 0) {
            v.push_back(i);
            v.push_back(x / i);
        }
    }
}

int getdp(int i, int j) {
    if (dp[i][j] != -1) return dp[i][j];
    if (i == 0 && j == 0) return dp[i][j] = 0;
    dp[i][j] = 0;
    for (int k = 0; k < (int)divisors[i].size(); k++) {
        int x = divisors[i][k];
        dp[i][j] |= !getdp(nxt[i][x], j);
        if (v[j] % v[x] == 0) dp[i][j] |= !getdp(nxt[i][x], nxt[j][x]);
        if (dp[i][j]) break;
    }
    for (int k = 0; k < (int)divisors[j].size(); k++) {
        int x = divisors[j][k];
        dp[i][j] |= !getdp(i, nxt[j][x]);
        if (v[i] % v[x] == 0) dp[i][j] |= !getdp(nxt[i][x], nxt[j][x]);
        if (dp[i][j]) break;
    }
    return dp[i][j];
}

int main() {
    freopen("game.in", "r", stdin);
    freopen("game.out", "w", stdout);

    int a, b;
    cin >> a >> b;
    fact(a);
    fact(b);
    sort(v.begin(), v.end());
    v.resize(unique(v.begin(), v.end()) - v.begin());
    n = v.size();
    
    for (int i = 0; i < n; i++) {
        for (int j = 1; j <= i; j++) {
            if (v[i] % v[j] == 0) {
                nxt[i][j] = lower_bound(v.begin(), v.end(), v[i] / v[j]) - v.begin();
                divisors[i].push_back(j);
            }
        }
    }

    int a1 = lower_bound(v.begin(), v.end(), a) - v.begin();
    int a2 = lower_bound(v.begin(), v.end(), b) - v.begin();

    memset(dp, -1, sizeof(dp));
    cout << (getdp(a1, a2) ? "Lucky wins" : "Alf wins") << endl;

    return 0;
}