import random
random.seed("basic03")

class TestGen:
    def __init__(self):
        self.test_number = 0

    def generate_samples(self):
        self.print_test(2, 2)
        self.print_test(2, 4)
        
    def generate_min_tests(self):
        for i in range(4):
            for j in range(4):
                self.print_test(i + 1, j + 1)
                                                                    
    def generate_hand_tests(self):
        self.print_test(2, 8)
        self.print_test(8, 4)
        #need more tests?

    def generate_random_test(self, maxn):
        self.print_test(random.randint(1, maxn), random.randint(1, maxn))

    def generate_max_tests(self, maxn):
        self.print_test(1, 10**9)
        self.print_test(10**9 - 1, 10**9)
        self.print_test(10**9 // 4, 10**9)
        self.print_test(931170240, 821620800)
        self.print_test(931170240, 536870912)
        self.print_test(536870912, 931170240)
        self.print_test(2**11 * 3**6 * 5**4, 2**10 * 3**6 * 5**4)
        self.print_test(2**11 * 3**6 * 5**4, 2**11 * 3**6 * 5**4)
        #need more tests?

    def print_test(self, a, b):
        self.test_number += 1
        test_name = "../tests/" + "{0:0=2d}".format(self.test_number)
        test_file = open(test_name, "w")
        print(a, b, file=test_file)
        test_file.close()

    def generate_all_tests(self):
        maxn = 10**9

        self.generate_samples()
        self.generate_hand_tests()
        self.generate_min_tests()
        
        for i in range(20):
            self.generate_random_test(maxn)
        self.generate_max_tests(maxn)        

import os, shutil
if os.path.exists('../tests'):
    print('Directory tests is already exists')
    shutil.rmtree('../tests', ignore_errors=False, onerror=None)
try:
    os.makedirs('../tests')
except OSError:
    pass

import time
start = time.time()
writer = TestGen()
writer.generate_all_tests()
finish = time.time()
print('All tests were generated. Elapsed time: ', finish - start)