#!/usr/bin/env perl

use strict;
use warnings;

use Cwd qw/getcwd/;
use File::Copy;
use File::Basename;

my $problem = basename getcwd;
my $author = shift;
my $source_name = $problem . "_" . $author;

die "Usage ./checkSolution.cmd author" if !defined($author);

system("g++ -O3 $source_name.cpp -o $source_name") == 0 or die "Can't compile $source_name.cpp";

for my $test (<./tests/*>) {
    next if ($test =~ /\.a$/);
    copy "$test", "$problem.in";
    if (system("./$source_name") == 0) {
        if (system("java -Xmx256M -Xss64M -cp ../../../lib/testlib4j.jar:. ru.ifmo.testlib.CheckerFramework Check $test $problem.out $test.a") == 0) {
            print "OK on test $test\n";
        } else {
            print "FAIL on test $test\n";
        }
    } else {
        print("RE on test $test\n");
    }
}
