#include <bits/stdc++.h>

using namespace std;

const int maxn = 1200;

struct pt {
    int x, y;
    pt() { x = y = 0; }
    pt(int x, int y) : x(x), y(y) {}

    void read() {
        scanf("%d%d", &x, &y);
    }

    void print() {
        printf("%d %d\n", x, y);
    }
};                 

bool operator == (const pt &a, const pt &b) { return a.x == b.x && a.y == b.y; }
bool operator != (const pt &a, const pt &b) { return !(a == b); }

struct line {
    long long a, b, c;
    line() { a = b = c = 0; }
    line(pt p1, pt p2) {
        a = p2.y - p1.y;
        b = p1.x - p2.x;
        c = -p1.x * a - p1.y * b;
    }
};

int l[maxn], r[maxn];
pt p[maxn];

int sign(long long x) {
    return x < 0 ? -1 : (x == 0 ? 0 : 1);
}

bool intersect(pt a, pt b, pt c, pt d) {
    line l1 = line(a, b);
    line l2 = line(c, d);
    bool ok = true;
    ok &= sign(a.x * l2.a + a.y * l2.b + l2.c) != sign(b.x * l2.a + b.y * l2.b + l2.c);
    ok &= sign(c.x * l1.a + c.y * l1.b + l1.c) != sign(d.x * l1.a + d.y * l1.b + l1.c);
    ok &= a != c;
    ok &= a != d;
    ok &= b != c;
    ok &= b != d;
    return ok;
}

vector <int> gr[maxn], grRev[maxn];

void adde(int v, int u) {
    gr[v].push_back(u);
    grRev[u].push_back(v);
}

bool was[maxn];
vector <int> topsort;

void dfs(int v) {
    was[v] = true;
    for (size_t i = 0; i < gr[v].size(); i++) {
        int u = gr[v][i];
        if (!was[u])
            dfs(u);
    }
    topsort.push_back(v);
}

int component[maxn];
              
void dfsRev(int v, int comp) {
    component[v] = comp;
    was[v] = true;
    for (size_t i = 0; i < grRev[v].size(); i++) {
        int u = grRev[v][i];
        if (!was[u])
            dfsRev(u, comp);
    }
}                

int main() {
    freopen("segments.in", "r", stdin);
    freopen("segments.out", "w", stdout);
    int n;
    scanf("%d", &n);
    for (int i = 0; i < n; i++)
        p[i].read();
    for (int i = 0; i < n; i++) {
        int v, u;
        scanf("%d%d", &v, &u);
        --v, --u;
        l[i] = v;
        r[i] = u;
    }

    for (int i = 0; i < n; i++) {
        adde(2 * i, 2 * l[i]);
        adde(2 * l[i], 2 * i);
        adde(2 * i, 2 * r[i]);
        adde(2 * r[i], 2 * i);
    }
    for (int i = 0; i < n; i++)
    for (int j = i + 1; j < n; j++) {
        if (j == l[i] || j == r[i])
            continue;
        if (intersect(p[i], p[l[i]], p[j], p[l[j]]) ||
            intersect(p[i], p[l[i]], p[j], p[r[j]]) ||
            intersect(p[i], p[r[i]], p[j], p[l[j]]) ||
            intersect(p[i], p[r[i]], p[j], p[r[j]])
            ) {
            adde(2 * i + 1, 2 * j);
            adde(2 * j + 1, 2 * i);
        }
    }

    for (int i = 0; i < 2 * n; i++)
        if (!was[i])
            dfs(i);
    //assert((int)topsort.size() == 2 * n);
    reverse(topsort.begin(), topsort.end());
    for (int i = 0; i < n; i++)
        was[i] = false;
    int comp = 0;
    for (int i = 0; i < n; i++)
        if (!was[i])
            dfsRev(i, comp++);
    for (int i = 0; i < 2 * n; i += 2)
        if (component[i] == component[i + 1]) {
            puts("NO");
            return 0;
        }
    puts("YES");
    for (int i = 0; i < n; i++)
        printf("%d\n", component[2 * i] > component[2 * i + 1] ? 1 : 2);
    return 0;
}                        