#include <bits/stdc++.h>
using namespace std;

#define TASK "segments"
typedef long long ll;

struct pt {
    int x, y;
    pt() {}
    pt(int x, int y) : x(x), y(y) {}
};

bool operator==(pt const& a, pt const& b) {
    return a.x == b.x && a.y == b.y;
}

pt operator-(pt const& a, pt const& b) {
    return pt(a.x - b.x, a.y - b.y);
}

ll operator*(pt const& a, pt const& b) {
    return 1LL * a.x * b.y - 1LL * b.x * a.y;
}

int sign(ll x) {
    return x < 0 ? -1 : x > 0 ? 1 : 0;
}

bool inter(pt const& a, pt const& b, pt const& c, pt const& d) {
    if (a == c || a == d || b == c || b == d)
        return false;
    ll v1 = (a - c) * (d - c);
    ll v2 = (b - c) * (d - c);

    ll u1 = (c - a) * (b - a);
    ll u2 = (d - a) * (b - a);
    return sign(v1) != sign(v2) && sign(u1) != sign(u2);
}

int rev(vector <int> const& e, int i) {
    if (e[e[i] * 2] == i / 2) return e[i] * 2;
    else return e[i] * 2 + 1;
}

vector <vector <int> > g, gr;
vector <int> q;
vector <char> vis;
void dfs1(int v) {
    vis[v] = true;
    for (int i = 0; i < (int)g[v].size(); i++) {
        if (!vis[g[v][i]]) dfs1(g[v][i]);
    }
    q.push_back(v);
}

vector <int> comp;
void dfs2(int v, int c) {
    comp[v] = c;
    for (int i = 0; i < (int)gr[v].size(); i++) {
        if (comp[gr[v][i]] == -1) dfs2(gr[v][i], c);
    }
}

int main() {
    freopen(TASK ".in", "r", stdin);
    freopen(TASK ".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;
    vector <pt> p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i].x >> p[i].y;
    }

    vector <int> e(2 * n);
    for (int i = 0; i < n; i++) {
        cin >> e[2 * i] >> e[2 * i + 1];
        --e[2 * i];
        --e[2 * i + 1];
    }

    g.resize(2 * n);
    gr.resize(2 * n);
    int ccnt = 0;
    for (int i = 0; i < 2 * n; i++) {
        pt a = p[i / 2];
        pt b = p[e[i]];

        int ri = rev(e, i);
        g[i].push_back(ri);
        g[i].push_back(rev(e, i ^ 1) ^ 1);
        gr[ri].push_back(i);
        gr[rev(e, i ^ 1) ^ 1].push_back(i);
        for (int j = i + 1; j < 2 * n; j++) {
            if (i == j) continue;
            pt c = p[j / 2];
            pt d = p[e[j]];

            if (inter(a, b, c, d)) {
                ++ccnt;
                g[i].push_back(j ^ 1);
                gr[j ^ 1].push_back(i);
            }
        }
    }
    cerr << ccnt << '\n';

    vis.resize(2 * n);
    for (int i = 0; i < 2 * n; i++) {
        if (!vis[i]) dfs1(i);
    }

    reverse(q.begin(), q.end());
    comp.assign(2 * n, -1);
    int cnt = 0;
    for (int i = 0; i < 2 * n; i++) {
        if (comp[q[i]] == -1) {
            dfs2(q[i], cnt++);
        }
    }

    for (int i = 0; i < 2 * n; i++) {
        if (comp[i] == comp[i ^ 1]) {
            cout << "NO\n";
            return 0;
        }
    }

    cout << "YES\n";
    for (int i = 0; i < n; i++) {
        cout << (comp[2 * i] > comp[2 * i + 1] ? 2 : 1) << "\n";
    }

    return 0;
}
