#include<iostream>
#include<cstdio>
#include<cmath>
#include<set>
#include<ctime>
#include<algorithm>
#include<vector> 
#include<cstring>
#include<string>
#include<map>
#define mp make_pair
#define scn second
#define frs first
#define pb push_back

#define NAME "tree"

using namespace std;
typedef unsigned long long ull;
typedef long long ll;
typedef pair<int, int> pi;
const int P = 239017;

int MIN = 1;
int func(int a, int b) {
	if (MIN)
		return a <= b;
	return a >= b;
}
vector<vector<pair<int, pi> > > t[100000];	
int killed[100000], sz[100000], a[100000], f[1000000];
vector<int> g[100000];
int n;


int build_size(int v, int p) {
    sz[v] = 1;
    for (int i = 0; i < g[v].size(); ++i) {
    	if (g[v][i] == p || killed[g[v][i]])
    		continue;
    	sz[v] += build_size(g[v][i], v);
    }
    return sz[v];
}
int find_start(int v, int p, int size) {
    for (int i = 0; i < g[v].size(); ++i) {
    	if (g[v][i] == p || killed[g[v][i]])
    		continue;
    	if (sz[g[v][i]] > size / 2)
    		return find_start(g[v][i], v, size);
    }
	return v;
}

set<pair<int, pi> > buf;

vector<pair<int, pi > > buf_to_vector() {
	vector<pair<int, pi > > ans;
	for (set<pair<int, pi > >::iterator i = buf.begin(); i != buf.end(); ++i)
		ans.pb(*i);
	return ans;
}

void add_into_buff(int val, int d, int vs) {
	pair<int, pi> tmp = mp(val, mp(0, 0));
	set<pair<int, pi> >::iterator found = buf.lower_bound(tmp);
	if (found == buf.end() || (*found).frs != val) {
		buf.insert(mp(val, mp(d, vs)));
	}
	else {
		buf.erase(found);
		tmp = *found;
		tmp.frs = val;
		tmp.scn.frs += d;
		tmp.scn.scn += vs;
		buf.insert(tmp);	
	}
}

void get_from_killed_into_buf(int v, int dir, int val) {
	for (int i = 0; i < t[v].size(); ++i) {
		if (i == dir)
			continue;
		for (int j = 0; j < t[v][i].size(); ++j) {
			if (func(t[v][i][j].frs, val))
				add_into_buff(t[v][i][j].frs, t[v][i][j].scn.frs, t[v][i][j].scn.scn);
		}		
	}
}

void find_path(int v, int p, int d, int val) {	
	if (func(f[v], val))
		val = f[v];	
	add_into_buff(val, d, 1);		
	for (int i = 0; i < g[v].size(); ++i) {
		if (g[v][i] == p)
			continue;          
		if (killed[g[v][i]]) {
			get_from_killed_into_buf(g[v][i], i, val);
			continue;
		}
		find_path(g[v][i], v, d + 1, val);
	}
}

ll iterate(int v) {
	for (int i = 0; i < g[v].size(); ++i) {
		if (killed[g[v][i]]) {
			buf.clear();
			get_from_killed_into_buf(g[v][i], i, f[v]);
			t[v].pb(buf_to_vector());
			continue;
		}
		buf.clear();		
		find_path(g[v][i], v, 2, f[v]);
		vector<pair<int, pi > > tmp = buf_to_vector();
		sort(tmp.begin(), tmp.end());
		t[v].pb(tmp);
	}	
	ll ans = 0;
	vector<pi> now;
	buf.clear();
	for (int i = 0; i < t[v].size(); ++i) {
		now.pb(mp(0, 0));
		for (int j = 0; j < t[v][i].size(); ++j) {
			if (func(f[v], t[v][i][j].frs)) {
				now[now.size() - 1].frs += t[v][i][j].scn.frs;
				now[now.size() - 1].scn += t[v][i][j].scn.scn;
			}
		}
	}
	for (int i = 0; i < now.size(); ++i) {
		ans += now[i].frs;
		for (int j = i + 1; j < now.size(); ++j)
			ans += (ll)now[i].frs * now[j].scn + (ll)now[i].scn * (now[j].frs - now[j].scn);
	}
	if (v == 1)	
		cerr << ans << " ";
	
	return ans;
}

ll dfs(int v) {
	ll ans = 0;	
	int sz = build_size(v, -1);
	v = find_start(v, -1, sz);	
	ans += iterate(v) * a[v];
	killed[v] = 1;
	for (int i = 0; i < g[v].size(); ++i) {
		if (!killed[g[v][i]])
			ans += dfs(g[v][i]);
	}
	return ans;
}



int main(){
    freopen(NAME ".in", "r", stdin); 
    freopen(NAME ".out", "w", stdout); 
    scanf("%d", &n);
    vector<pi> arr;
    for (int i = 1; i <= n; ++i) {
    	scanf("%d", &a[i]);
    	arr.pb(mp(a[i], i));    	    	    		
    }
    sort(arr.begin(), arr.end());
    for (int i = 0; i < arr.size(); ++i) {    	
    	f[arr[i].scn] = i;
    }
    for (int i = 0; i < n - 1; ++i) {
    	int a, b;
    	scanf("%d%d", &a, &b);
    	g[a].pb(b);
    	g[b].pb(a);
    }
    ll mn = dfs(1);
    for (int i = 1; i <= n; ++i)
    	killed[i] = 0, t[i].clear();
    MIN = 0;
    ll mx = dfs(1);
    //for (int i = 0; i < t[1].size(); ++i)
    //	cerr << t[1][i].frs << " " << t[1][i].scn << "\n";
    //cerr << mn << " " << mx;
    printf("%I64d", mx - mn);    
    return 0;
}




